<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.consign_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/shopping/consign";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          // searchShow: true,
          // searchMenuSpan: 6,
          border: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          labelWidth: 120,
          searchMenuPosition: "center",
          column: [
            {
              label: "主键ID",
              prop: "id",
              hide: true,
              display: false,
            },
            {
              label: "订单ID",
              prop: "orderId",
              hide: true,
              display: false,
            },
            {
              label: "商品ID",
              prop: "goodsId",
              hide: true,
              display: false,
            },
            {
              label: "标题",
              prop: "title",
              width: 130,
              span: 24,
            },
            {
              label: "商品名称",
              prop: "goodsName",
              display: false,
              width: 120,
              span: 24,
            },
            {
              label: "货号",
              prop: "productNo",
              width: 100,
              hide: true,
              rules: [{
                required: true,
                message: "请输入货号",
                trigger: "blur"
              }]
            },
            {
              label: "寄售场次",
              prop: "consignConfigId",
              type: "select",
              width: 150,
              dicUrl: "/api/shopping/consignconfig/selectList",
              props: {
                label: "title",
                value: "id"
              },
              search: true,
            },
            {
              label: "寄售用户ID",
              prop: "consignUserId",
              hide: true,
              display: false,
            },
            {
              label: "寄售人",
              prop: "consignUserName",
              display: false,
              search: true
            },
            {
              label: "寄售人电话",
              prop: "consignUserPhone",
              display: false,
              search: true,
              searchLabelWidth: 100,
              width: 100,
            },
            {
              label: "来源",
              prop: "consignForDisplayName",
              display: false,
            },
            {
              label: "寄售来源",
              prop: "consignFor",
              type: "select",
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=consign_for",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType: "number",
              hide: true,
              display: false,
              search: true,
              rules: [{
                required: true,
                message: "请选择寄售来源",
                trigger: "blur"
              }]
            },
            {
              label: "寄售天数",
              prop: "consignDays",
              display: false,
            },
            {
              label: "在售天数",
              prop: "saleDays",
              display: false,
            },
            {
              label: "取得价",
              prop: "obtainPrice",
              rules: [{
                required: true,
                message: "请输入取得价",
                trigger: "blur"
              }]
            },
            {
              label: "抢购价",
              prop: "consignPrice",
              rules: [{
                required: true,
                message: "请输入抢购价",
                trigger: "blur"
              }]
            },
            {
              label: "交割价",
              prop: "deliveryPrice",
              rules: [{
                required: true,
                message: "请输入交割价",
                trigger: "blur"
              }]
            },
            {
              label: "是否交割",
              prop: "isDeliveryDisplayName",
              display: false,
            },
            {
              label: "是否交割",
              prop: "isDelivery",
              type: "select",
              dicUrl: "/api/blade-system/dict/dictionary?code=yes_no",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType: "number",
              display: false,
              hide: true,
              rules: [{
                required: true,
                message: "请选择是否交割",
                trigger: "blur"
              }]
            },
            {
              label: "是否上架",
              prop: "isSaleDisplayName",
              display: false,
            },
            {
              label: "是否上架",
              prop: "isSale",
              type: "select",
              dicUrl: "/api/blade-system/dict/dictionary?code=yes_no",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType: "number",
              hide: true,
              rules: [{
                required: true,
                message: "请选择是否上架",
                trigger: "blur"
              }]
            },
            {
              label: "状态",
              prop: "consignStateDisplayName",
              display: false,
            },
            {
              label: "寄售状态",
              prop: "consignState",
              type: "select",
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=consign_state",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType: "number",
              hide: true,
              display: false,
              rules: [{
                required: true,
                message: "请选择寄售状态",
                trigger: "blur"
              }]
            },
            {
              label: "数量",
              prop: "totalNum",
              type: "number",
              rules: [{
                required: true,
                message: "请输入数量",
                trigger: "blur"
              }]
            },
            {
              label: "剩余数量",
              prop: "nowStock",
              type: "number",
              rules: [{
                required: true,
                message: "请输入剩余数量",
                trigger: "blur"
              }]
            },
            {
              label: "开始时间",
              prop: "startTime",
              type: "datetime",
              format: "yyyy-MM-dd HH:mm:ss",
              valueFormat:"yyyy-MM-dd HH:mm:ss",
              width: 150,
              addDisplay: false,
              rules: [{
                required: true,
                message: "请输入开始时间",
                trigger: "blur"
              }]
            },
            {
              label: "结束时间",
              prop: "endTime",
              type: "datetime",
              format: "yyyy-MM-dd HH:mm:ss",
              valueFormat:"yyyy-MM-dd HH:mm:ss",
              width: 150,
              addDisplay: false,
              rules: [{
                required: true,
                message: "请输入结束时间",
                trigger: "blur"
              }]
            },
            {
              label: "创建时间",
              prop: "createTime",
              display: false,
              width: 150,
              rules: [{
                required: true,
                message: "请输入创建时间",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.consign_add, false),
          viewBtn: this.vaildData(this.permission.consign_view, false),
          delBtn: this.vaildData(this.permission.consign_delete, false),
          editBtn: this.vaildData(this.permission.consign_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
